package sysinfo

import "encoding/json"

type PackagesCollector struct{}

func (PackagesCollector) SectionKey() string { return "packages" }

func (PackagesCollector) EnsurePrerequisites(_ PackageManager, _ *Context) error {
	return nil // core tool
}

func (PackagesCollector) IsSupported(pm PackageManager, _ *Context) bool {
	return pm.ExecExists("dpkg-query")
}

func (PackagesCollector) CollectData(c *Context) (json.RawMessage, error) {
	out := c.SafeRun("dpkg-query", "-W", "-f=${Package} ${Version}\\n")
	return json.Marshal(map[string]string{"dpkg": out})
}
