package sysinfo

import "encoding/json"

// Snapshot stores timestamp + raw section blobs.
type Snapshot struct {
	Timestamp string                       `json:"snapshot_time"`
	Sections  map[string]json.RawMessage   `json:"-"`
}

// MarshalJSON injects raw sections into root object.
func (s *Snapshot) MarshalJSON() ([]byte, error) {
	obj := map[string]json.RawMessage{
		"snapshot_time": json.RawMessage(
			[]byte(`"` + s.Timestamp + `"`)),
	}
	for k, v := range s.Sections {
		obj[k] = v
	}
	return json.Marshal(obj)
}
